<?php

class Ambient_Routee_Helper_Data extends Mage_Core_Helper_Abstract {

    public function creteuuid() {
        $this->prepareLogsData('before calling auth api', 200, 'auth', '');
        try {
            $requestcont = array();
            $requestcont['username'] = Mage::getStoreConfig('routeesection/routeegroup/routee_username');
            $requestcont['password'] = Mage::getStoreConfig('routeesection/routeegroup/routee_pwd');
            $requestcont['source'] = "Magento";
            $requestcont['type'] = "E-COMMERCE";
            $requestcont['version'] = Mage::getVersion();
            $requestcont['domain'] = Mage::getBaseUrl();

            $json = Mage::helper('core')->jsonEncode($requestcont);

            $url = "https://api.waymore.io/api/authenticate";

            $c = curl_init();
            curl_setopt($c, CURLOPT_URL, $url);
            curl_setopt($c, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
            curl_setopt($c, CURLOPT_POST, true);
            curl_setopt($c, CURLOPT_POSTFIELDS, $json);
            curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($c, CURLOPT_TIMEOUT, 30);
            $response = curl_exec($c);
            curl_close($c);

            $result = Mage::helper('core')->jsonDecode($response);
            $this->prepareLogsData('connection successful', 200, 'auth', $result['uuid']);
            return $result['uuid'];
        }catch (Exception $exception){
            $this->prepareLogsData($exception->getMessage(), $exception->getCode(), 'auth', '');
            return null;
        }
    }

    public function prepareMessage()
    {

    }

    public function prepareLogsData($message, $code, $event, $uuid)
    {
        try {
            $data = [
                'method' => $event,
                'desc' => $message,
                'code' => $code
            ];
            $this->saveLogs($data, $uuid, $event);
            $this->sendErrorLog($code, $event, $data, $uuid);
        }catch (Exception $exception){}
    }

    public function saveLogs($data,$getUuid, $event, $logType='event'){
        try {
            $saveData = array(
                'store_url' => Mage::getBaseUrl(),
                'event_type' => $event,
                'log_type' => $logType,
                'log_data' => $data,
                'created_at' => gmdate('d-m-Y H:i:s'),
                'is_exported' => 0
            );
            $model = Mage::getModel('routee/routee_shop_logs')->addData($saveData);
            $model->save(); //save data
            return "Data successfully inserted.";
        } catch (Exception $e) {
            return $e->getMessage();
        }
    }

    public function sendErrorLog($code, $event, $data, $uuid = null, $logType='event') {
        $getUuid = !empty($uuid) ? $uuid : Mage::getStoreConfig('routeesection/routeegroup/routee_mmid');
        if($code != 200) {
            $apiData = array(
                'mode' => $logType,
                'event' => $event,
                'code' => $code,
                'exception_message' => $data['desc']
            );
            $url = 'https://autoforms.routee.net/u001/log.php';
            $json = Mage::helper('core')->jsonEncode($apiData);

            $c = curl_init();
            curl_setopt($c, CURLOPT_URL, $url);
            curl_setopt($c, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
            curl_setopt($c, CURLOPT_POST, true);
            curl_setopt($c, CURLOPT_POSTFIELDS, $json);
            curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($c, CURLOPT_TIMEOUT, 30);
            $response = curl_exec($c);
            curl_close($c);
        }
    }

}
